'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.preprocessor = undefined;

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _babelCore = require('babel-core');

var Babel = _interopRequireWildcard(_babelCore);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var preprocessor = function preprocessor(events, system, opts) {
    var babelConfig = {};
    if (typeof opts.configFile === 'string') {
        try {
            babelConfig = JSON.parse(_fs2.default.readFileSync(_path2.default.join(process.cwd(), opts.configFile), {
                encoding: 'utf8',
                flag: 'r'
            }));
        } catch (e) {
            system.handleError(e);
        }
    }
    babelConfig = Object.assign(babelConfig, {
        sourceMaps: 'both',
        sourceFileName: null,
        sourceMapTarget: null
    });
    events.onLoad = function () {};
    events.onFileLoad = function (source, filename) {
        var tmpFilename = _path2.default.join(system.tmpDirectory, system.helper.getFileKey(filename));
        babelConfig.sourceFileName = filename;
        babelConfig.sourceMapTarget = tmpFilename;
        var transpiled = Babel.transform(source, babelConfig);
        _fs2.default.writeFileSync(tmpFilename, transpiled.code);
        return {
            filename: tmpFilename,
            source: transpiled.code
        };
    };
    events.onExit = function () {};
};

exports.preprocessor = preprocessor;